import pygame,pickle,os,sys
from pygame.locals import *

from levcreatorRewind import *


class AMap:
    def __init__(self,screen,mapdata,name):
        self.mapped = mapdata
        self.screen = screen
        self.name   = name
        
        
        self.anim   = 0.0 #animate water
        self.flag   = 0
        
        self.objects    = {}
        self.objects["enemies"]    = []
        self.objects["bosses"]     = []
        self.objects["drop_items"] = []
        self.objects["npc"]        = []
        self.objects["hazards"]    = []
        self.objects["specials"]   = []
        self.objects["portals"]    = []

        #this dictionary is used for things such as block pushes, explosions and burnt items changeing the map
        self.changes = {}
        self.changes["main"]       = {}
        self.changes["fore"]       = {}
        self.changes["tweaks"]     = {}
        self.changes["background"] = {}
        
        #will be used for persistent map changes that never reset through the course of a game
        self.perm_changes = {}      
        
    def loadmap(self):
        def busy_busy(key):
            #a silly function to ensure that the final position of an object is not drawn until
            #its animation is complete
            for change in self.objects["specials"]:
                try:
                    if key == change.newchoords and not change.done:
                        return 1
                except AttributeError: pass
            else: return 0

        #draw the primary background fill color        
        self.screen.fill(self.mapped["background"]["colour"],(0,0,1000,700))

        # this flag tells the function which water image to load so that waves animate
        # could be used for other types of background animations as well
        if pygame.time.get_ticks() - self.anim > 1000/4:
            if self.flag == 1:
                self.anim = pygame.time.get_ticks()
                self.flag = 0
            else:
                self.anim = pygame.time.get_ticks()
                self.flag = 1

        #draw the background
        for key in self.mapped["background"]:
            if key == "colour": pass
            #the 'elif' sections below animate water
            #if animation is not desired the else block is all that is necessary
            elif self.mapped["background"][key] == (6*50,2*50,50,50) and self.flag == 0:
                self.screen.blit(graphic["bgtiles"],(key[0]-500,key[1]),self.mapped["background"][key])
            elif self.mapped["background"][key] == (6*50,2*50,50,50) and self.flag == 1:
                self.screen.blit(pallet[1],(key[0]-500,key[1]),(0,12*50,50,50))
            else:
                self.screen.blit(graphic["bgtiles"],(key[0]-500,key[1]),self.mapped["background"][key])
                
        #draw any background changes
        for key in self.changes["background"]:
                self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])

        #draw the layer that the player is on        
        for key in self.mapped["main"]:
            if key not in self.changes["main"] and key not in self.changes["fore"]:
                #the 'if' and 'elif' sections below animate water
                #if animation is not desired the else block is all that is necessary
                if   self.mapped["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 0:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])
                elif self.mapped["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 1:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),(0,12*50,50,50))
                else:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])

        for key in self.changes["main"]:
            if self.changes["main"][key] != None and not busy_busy(key):
                if   self.changes["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 0:
                    self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])
                elif self.changes["main"][key] == (1,(3*50,11*50,50,50)) and self.flag == 1:
                    self.screen.blit(pallet[self.changes["main"][key][0]],(key[0]-500,key[1]),(0,12*50,50,50))
                else:
                    self.screen.blit(pallet[self.changes["main"][key][0]],(key[0]-500,key[1]),self.changes["main"][key][1])
                
    def paintfore(self):
        #draws the cells that the player will pass underneath
        for key in self.mapped["main"]:
            if key in self.forelis and key not in self.changes["fore"]:
                self.screen.blit(pallet[self.mapped["main"][key][0]],(key[0]-500,key[1]),self.mapped["main"][key][1])
            elif key in self.changes["fore"]:
                self.screen.blit(pallet[self.mapped["main"][key][0]],(globs.Level.changes["fore"][key][0]-500,globs.Level.changes["fore"][key][1]),self.mapped["main"][key][1])
                   

    def getlists(self):
        self.waterlis = {}
        self.solidlis = {}
        self.forelis  = {}
        self.hazlis   = {}
   
        for key in self.mapped["tweaks"]:
                if   self.mapped["tweaks"][key]  == 1        : self.solidlis[key] = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == 0        : self.waterlis[key] = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == "fore"   : self.forelis[key]  = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == "solidfore" :
                    self.solidlis[key] = ((key[0]-500,key[1],50,50))
                    self.forelis[key]  = ((key[0]-500,key[1],50,50))
                elif self.mapped["tweaks"][key]  == "hazard" : self.hazlis[key]  = ((key[0]-500,key[1],50,50))
            

    def getmask(self):
        self.getlists()
        def paintelement(adict,mapdata):
            element = pygame.Surface((1000,700)).convert_alpha()
            element.fill((0,0,0,0))
            for key in adict:
                if key not in self.changes["main"]:
                    element.blit(pallet[mapdata["main"][key][0]],(key[0]-500,key[1]),mapdata["main"][key][1])
                else:
                    element.blit(pallet[self.changes["main"][key][0]],(key[0]-500,key[1]),self.changes["main"][key][1])
            return element
        def paintdense(adict,mapdata):
            dense = pygame.Surface((1000,700)).convert_alpha()
            dense.fill((0,0,0,0))
            for key in adict:
                dense.fill((125,125,125),(key[0]-500,key[1],50,50))
            return dense
                
        solids = paintelement(self.solidlis,self.mapped)
        liquid = paintelement(self.waterlis,self.mapped)

        dsolids= paintdense(self.solidlis,self.mapped)
        dliquid= paintdense(self.waterlis,self.mapped)
        dhazard= paintdense(self.hazlis,self.mapped)
        self.solidmask = pygame.mask.from_surface(solids)
        self.watermask = pygame.mask.from_surface(liquid)
      
        self.dense_solidmask = pygame.mask.from_surface(dsolids)
        self.dense_watermask = pygame.mask.from_surface(dliquid)
        self.dense_hazmask   = pygame.mask.from_surface(dhazard)



